-- for CCLuaEngine traceback
function __G__TRACKBACK__(msg)
    print("----------------------------------------")
    print("LUA ERROR: " .. tostring(msg) .. "\n")
    print(debug.traceback())
    print("----------------------------------------")
end
require "CrossRealmGameLayer"
iWinsize = CCDirector:sharedDirector():getVisibleSize()
origin = CCDirector:sharedDirector():getVisibleOrigin()
TAG_MENU = 1000
mainLayer = nil
iMaxPage = 0
iNowPage = 0
scrollView = nil
TAG_BACK = 1000
TAG_PLAY = 1001
TAG_LABNOWPAGE = 1002
TAG_SELECT = 1003
TAG_SORT = 1004
TAG_MENU = 1005
TAG_TOP = 1006
TAG_SEASON = 1007
TAG_LINE = 3000
TAG_RBG  = 3001
TAG_SCROLL = 3002
TAG_SCROLL_POINT = 10000
touchBeginPoint = nil
scrollBegin = nil
local function unShowRightBtn()
    local rbg = tolua.cast(mainLayer:getChildByTag(TAG_RBG),"CCSprite")
    mainLayer:removeChildByTag(TAG_LINE, true);
    local btnLine  = CCSprite:create("train_line.png");
    btnLine:setAnchorPoint(ccp(1,0));
    btnLine:setPosition(rbg:getPosition());
    btnLine:setTag(TAG_LINE);
    mainLayer:addChild(btnLine);
    
    local x = rbg:getContentSize().width;
    btnLine:setScaleX(x);
    mainLayer:getChildByTag(TAG_MENU):getChildByTag(TAG_PLAY):setVisible(false);
    rbg:setVisible(false);
end

local function showRightBtn()
    local item = tolua.cast(mainLayer:getChildByTag(TAG_MENU):getChildByTag(TAG_PLAY),"MyMenuItem");
    item:setVisible(true);
    item:removeChildByTag(MY_MENU_ITEM_STRING, true);
    item:addString("上传球会",30);
    
    local rbg = tolua.cast(mainLayer:getChildByTag(TAG_RBG),"CCSprite");
    rbg:setVisible(true);
    mainLayer:removeChildByTag(TAG_LINE, true);
end

local function doPageTurn()
    for i = 0,iMaxPage - 1 do
        local sp = tolua.cast(mainLayer:getChildByTag(TAG_SCROLL_POINT + i),"CCSprite")
        if i == iNowPage then
            sp:setTexture(CCTextureCache:sharedTextureCache():addImage("img_point_2.png"))
            sp:setScale(0.7)
            sp:stopAllActions()
            local action = CCSequence:createWithTwoActions(CCScaleTo:create(0.2, 1.1),CCScaleTo:create(0.2, 1.0))
            sp:runAction(action)
        else
            sp:setTexture(CCTextureCache:sharedTextureCache():addImage("img_point_1.png"))
        end
    end
end

local function createSaiCheng(iInfo)
    local layer = CCLayer:create()
    local spBg = CCSprite:create("kf_xuanba_bg.png")
    spBg:setPosition(ccp(iWinsize.width/2,470/2))
    layer:addChild(spBg)
    if iInfo == 1 then
        local cup = CCSprite:create("kf_cup.png")
        cup:setPosition(ccp(iWinsize.width/2 + 220,470/2))
        layer:addChild(cup)

        local labInfo = CCLabelTTF:create("截止日期:", "Arial-BoldMT" , 32);
        labInfo:setPosition(ccp(iWinsize.width/2 - 400,470/2 + 150));
        labInfo:setAnchorPoint(ccp(0,0.5))
        labInfo:setColor(ccc3(0x61,0x81,0xc1))
        layer:addChild(labInfo,1);

        local labInfo1 = CCLabelTTF:create("每周一上午10:00", "Arial-BoldMT" , 32);
        labInfo1:setPosition(ccp(iWinsize.width/2 - 240,470/2 + 150));
        labInfo1:setAnchorPoint(ccp(0,0.5))
        labInfo1:setColor(ccc3(0xd8,0xff,0x00))
        layer:addChild(labInfo1,1);

        local labInfo2 = CCLabelTTF:create("截止时间之前球队排名本服          的队伍进入萌卡杯的争夺。", "Arial-BoldMT",22,CCSizeMake(410,65),kCCTextAlignmentLeft);
        labInfo2:setPosition(ccp(iWinsize.width/2 - 400,470/2 + 60));
        labInfo2:setAnchorPoint(ccp(0,0.5))
        labInfo2:setColor(ccc3(0xc1,0xe2,0xff))
        layer:addChild(labInfo2,1);

        local labTop8 = CCLabelTTF:create("前8名", "Arial-BoldMT" , 22);
        labTop8:setPosition(ccp(iWinsize.width/2 - 400 + 268,470/2 + 81));
        labTop8:setAnchorPoint(ccp(0,0.5))
        labTop8:setColor(ccc3(0xff,0x96,0x00))
        layer:addChild(labTop8,1);

        local line = CCSprite:create("line.png");
        line:setPosition(ccp(iWinsize.width/2 - 200,470/2 - 20))
        line:setScaleX(400)
        layer:addChild(line)

        local labInfo3 = CCLabelTTF:create("本次参战服:", "Arial-BoldMT" , 32);
        labInfo3:setPosition(ccp(iWinsize.width/2 - 400,470/2 - 60));
        labInfo3:setAnchorPoint(ccp(0,0.5))
        labInfo3:setColor(ccc3(0x61,0x81,0xc1))
        layer:addChild(labInfo3,1);
    elseif iInfo == 2 then
        local cup = CCSprite:create("kf_cup.png")
        cup:setPosition(ccp(iWinsize.width/2 - 220,470/2))
        layer:addChild(cup)

        local labInfo = CCLabelTTF:create("第3轮 2014-04-10", "Arial-BoldMT" , 34);
        labInfo:setPosition(ccp(iWinsize.width/2 + 210,470/2 + 150));
        labInfo:setColor(ccc3(0xd8,0xff,0x00))
        layer:addChild(labInfo,1);

        local line = CCSprite:create("kf_line2.png");
        line:setPosition(ccp(iWinsize.width/2 + 210,470/2 + 110))
        layer:addChild(line)

        local labInfo1 = CCLabelTTF:create("每日赛程如下,赛事采用", "Arial-BoldMT" , 24);
        labInfo1:setPosition(ccp(iWinsize.width/2 + 20,470/2 + 70));
        labInfo1:setAnchorPoint(ccp(0,0.5))
        labInfo1:setColor(ccc3(0xc1,0xe2,0xff))
        layer:addChild(labInfo1,1);

        local labInfo2 = CCLabelTTF:create("7战4胜制", "Arial-BoldMT" ,24);
        labInfo2:setPosition(ccp(iWinsize.width/2 + 290,470/2 + 70));
        labInfo2:setAnchorPoint(ccp(0,0.5))
        labInfo2:setColor(ccc3(0xd8,0xff,0x00))
        layer:addChild(labInfo2,1);

        local line1 = CCSprite:create("kf_line2.png");
        line1:setPosition(ccp(iWinsize.width/2 + 210,470/2 + 40))
        layer:addChild(line1)

        local arrTimes = {"09:30","11:30","13:30","15:30","17:30","19:30","21:30"}
        for i = 0,6 do
        	local labInfo = CCLabelTTF:create("第"..(i+1).."场", "Arial-BoldMT" , 24);
        	labInfo:setPosition(ccp(iWinsize.width/2 + 45 + (i % 2) * 220,470/2 + 10 - 50 * math.floor(i / 2)))
        	labInfo:setColor(ccc3(0xc1,0xe2,0xff))
        	layer:addChild(labInfo)

        	local labInfo1 = CCLabelTTF:create(arrTimes[i + 1], "Arial-BoldMT" , 24);
        	labInfo1:setPosition(ccp(iWinsize.width/2 + 45 + (i % 2) * 220 + 100,470/2 + 10 - 50 * math.floor(i / 2)))
        	labInfo1:setColor(ccc3(0xff,0x96,0x00))
        	layer:addChild(labInfo1)

        	local line2 = CCSprite:create("kf_line2.png");
        	line2:setPosition(ccp(iWinsize.width/2 + 210,470/2 + 10 - 50 * math.floor(i / 2) - 25))
        	layer:addChild(line2)
        end
    elseif iInfo == 3 then
    	local result = CCSprite:create("kf_result.png")
       	result:setPosition(ccp(iWinsize.width/2,470/2 + 53))
       	layer:addChild(result)

        local cup = CCSprite:create("kf_cup.png")
        cup:setPosition(result:convertToNodeSpace(ccp(iWinsize.width/2,470/2)))
        result:addChild(cup)

        for i=0,1 do
        	local spTeam1 = CCSprite:create("team_slogo_1.png")
	        spTeam1:setPosition(ccp(155 + i * 602,215))
	        result:addChild(spTeam1)

	        local labTeam1Name = CCLabelTTF:create("这里是测试名字", "Arial-BoldMT" , 24);
	    	labTeam1Name:setPosition(ccp(155 + i * 602,150))
	    	labTeam1Name:setColor(ccc3(0xff,0xf0,0x00))
	    	result:addChild(labTeam1Name)

	    	local labTeam1Score = CCLabelTTF:create("4", GameUtil:getTTF() , 81);
	    	labTeam1Score:setPosition(ccp(155 + i * 602,50))
	    	labTeam1Score:setColor(ccc3(0xff,0xf0,0x00))
	    	result:addChild(labTeam1Score)

	    	local labTeam1Server = CCLabelTTF:create("快用1服", "Arial-BoldMT" , 24);
	    	labTeam1Server:setPosition(ccp(155 + i * 602,-30))
	    	labTeam1Server:setColor(ccc3(0xff,0xf0,0x00))
	    	result:addChild(labTeam1Server)
        end
    end
    return layer
end

 local function adJustScrollView()
        scrollView:unscheduleAllSelectors()
        scrollView:getContainer():stopAllActions()
        local iScrollWidth = scrollView:getContentSize().width
        local oldX = scrollBegin.x;
        local x = scrollView:getContentOffset().x
        local iSign = 1

        print("oldX"..oldX)
        print("x"..x)
        if x < 0 then 
            iSign = -1 
        end

        local offset = math.abs(math.floor(x)) % iScrollWidth * iSign
        local adjustPos = ccp(0,0)
        local adjustAnimDelay = nil
        local iSpeed = 1000
        
        if math.abs(oldX - x) > 100 then
            if oldX < x then
                adjustPos = ccp(scrollView:getContentOffset().x - offset,scrollView:getContentOffset().y)
            else
                adjustPos = ccp(scrollView:getContentOffset().x - iScrollWidth - offset,scrollView:getContentOffset().y)
            end
        else
            if offset < -iScrollWidth/2.0 then
                adjustPos = ccp(scrollView:getContentOffset().x - iScrollWidth - offset,scrollView:getContentOffset().y)
            else
                adjustPos = ccp(scrollView:getContentOffset().x - offset,scrollView:getContentOffset().y)
            end
        end
    
        if adjustPos.x < - iScrollWidth * (iMaxPage - 1) then
            adjustPos.x = - iScrollWidth * (iMaxPage - 1)
        end

        adjustAnimDelay =  math.abs(adjustPos.x - scrollView:getContentOffset().x) / iSpeed
        local iPage = math.abs(adjustPos.x/iScrollWidth)

        if iPage % 1 > 0.5 then
            iPage = math.ceil(iPage)
        else
            iPage = math.floor(iPage)
        end

        if iPage ~= iNowPage then
            iNowPage = iPage
             doPageTurn()
            print(iNowPage)
        end
        scrollView:setContentOffsetInDuration(adjustPos,adjustAnimDelay)
       
    end

local function main()
    -- avoid memory leak
    collectgarbage("setpause", 100)
    collectgarbage("setstepmul", 5000)

    local cclog = function(...)
        print(string.format(...))
    end

    function init()
        mainLayer = CCLayer:create();
        CCTexture2D:setDefaultAlphaPixelFormat(kCCTexture2DPixelFormat_RGB565);
        local bg = CCSprite:create("pvp_bg.png");
        bg:setPosition(ccp(iWinsize.width/2,iWinsize.height/2));
        mainLayer:addChild(bg);
        CCTexture2D:setDefaultAlphaPixelFormat(kCCTexture2DPixelFormat_RGBA8888);
        
        

        local bgDown = CCSprite:create("train_down.png");
        bgDown:setPosition(ccp(iWinsize.width/2,bgDown:getContentSize().height/2));
        mainLayer:addChild(bgDown);
        
        local bgTop = CCSprite:create("train_top.png");
        bgTop:setAnchorPoint(ccp(0.5,1));
        bgTop:setPosition(ccp(iWinsize.width/2,iWinsize.height));
        mainLayer:addChild(bgTop);
        
        local labTop = CCLabelTTF:create("跨服战", GameUtil:getTTF() , 40);
        labTop:setPosition(ccp(iWinsize.width/2 - 50,iWinsize.height - bgTop:getContentSize().height/2 + 5));
        mainLayer:addChild(labTop,1);
        mainLayer:setTag(TAG_TOP);
        GameUtil:createStroke(labTop, ccc3(0x00,0x00,0x00), false, 1);

        local labNum = CCLabelTTF:create("(选拔)", "Arial-BoldMT", 22);
        labNum:setPosition(ccp(iWinsize.width/2 + 50,iWinsize.height - bgTop:getContentSize().height/2));
        labNum:setTag(TAG_SEASON);
        mainLayer:addChild(labNum,1);
        GameUtil:createStroke(labNum, ccc3(0x05, 0x30, 0x6b), false, 2);
        
        local menu = CCMenu:create();
        menu:setPosition(ccp(0,0));
        menu:setTag(TAG_MENU);
        mainLayer:addChild(menu,1);
        
        local lBg = CCSprite:create("btn_rbtn_bg.png");
        lBg:setAnchorPoint(ccp(1,0));
        lBg:setPosition(ccp(iWinsize.width,0));
        lBg:setTag(TAG_RBG);
        mainLayer:addChild(lBg);
        
        local btnPlay = MyMenuItem:createWithFileName("btn_yellow_1.png");
        btnPlay:setAnchorPoint(ccp(1,0));
        btnPlay:setTag(TAG_PLAY);
        btnPlay:setPosition(ccp(iWinsize.width - 7,5));
        menu:addChild(btnPlay);
        btnPlay:addString("上传球会",30);

        local rBg = CCSprite:create("btn_lbtn_bg.png");
        rBg:setAnchorPoint(ccp(0,0));
        rBg:setPosition(ccp(0,0));
        mainLayer:addChild(rBg);
        
        local btnBack = MyMenuItem:createWithFileName("btn_green_1.png");
        btnBack:setAnchorPoint(ccp(0,0));
        btnBack:setTag(TAG_BACK);
        btnBack:setPosition(ccp(7,5));
        menu:addChild(btnBack);
        
        local btnLine  = CCSprite:create("train_line.png");
        btnLine:setAnchorPoint(ccp(0.5,0));
        btnLine:setPosition(ccp(iWinsize.width/2,0));
        mainLayer:addChild(btnLine);
        local x = (iWinsize.width - lBg:getContentSize().width) / btnLine:getContentSize().width;
        btnLine:setScaleX(x);
        


        
        iScrollWidth = iWinsize.width;
        local iScrollHight = 470;
        
        
        local conterLayer = CCLayer:create();
        conterLayer:setContentSize(CCSizeMake(iScrollWidth, iScrollHight));
        scrollView = CCScrollView:create(CCSizeMake(iScrollWidth, iScrollHight),conterLayer);
        scrollView:setPosition(ccp(0,iWinsize.height/2 - 230));
        scrollView:setTouchEnabled(true);
        scrollView:setContentOffset(ccp(0,0));
        scrollView:setTouchPrority(kCCMenuHandlerPriority);
        scrollView:setDirection(kCCScrollViewDirectionHorizontal);
        scrollView:setTag(TAG_SCROLL);

        mainLayer:addChild(scrollView);
        
        iMaxPage = 3;
        iNowPage = 0;

        for i=0,iMaxPage - 1 do
            local point;
            if i == iNowPage then
                point = CCSprite:create("img_point_2_1.png");
            else
                point = CCSprite:create("img_point_1_1.png");
            end
            point:setPosition(ccp(iWinsize.width/2 + 30 * (i - (iMaxPage - 1)/2.0),45));
            point:setTag(TAG_SCROLL_POINT + i);
            mainLayer:addChild(point);
        end
        conterLayer:addChild(createSaiCheng(3))

        local gameLayer = CrossRealmGameLayer:create()
        gameLayer:setPosition(ccp(iWinsize.width,0))
        conterLayer:addChild(gameLayer)
        
        doPageTurn();

        local function onTouchBegan(x, y)
            --cclog("onTouchMoved: %0.2f, %0.2f", x, y)
            touchBeginPoint = ccp(x,y)
            scrollBegin = scrollView:getContentOffset()
            return true
        end

        local function onTouchMoved(x, y)
            --cclog("onTouchMoved: %0.2f, %0.2f", x, y)
        end

        local function onTouchEnded(x, y)
            --cclog("onTouchEnded: %0.2f, %0.2f", x, y)
            adJustScrollView()
            scrollBegin = nil
        end

        local function onTouch(eventType, x, y)
            if eventType == "began" then   
                return onTouchBegan(x, y)
            elseif eventType == "moved" then
                return onTouchMoved(x, y)
            else
                return onTouchEnded(x, y)
            end
        end

        mainLayer:registerScriptTouchHandler(onTouch)
        mainLayer:setTouchEnabled(true)
        return mainLayer;
    end

    local sceneGame = CCScene:create()
    local sp = CCSprite:create("open_logo.png")
    sp:setPosition(ccp(iWinsize.width/2,iWinsize.height/2))
    sceneGame:addChild(sp)
    sceneGame:addChild(init());

    CCDirector:sharedDirector():pushScene(sceneGame)
    cclog("result is")
end

xpcall(main, __G__TRACKBACK__)